var quick_chat_url = custom.quick_chat_url;
var quick_chat_date_fmt = custom.quick_chat_date_fmt;
var quick_chat_time_fmt = custom.quick_chat_time_fmt;
var quick_chat_is_admin = custom.quick_chat_is_admin;
var delete_what_string = custom.delete_what_string;
var smileArray = { ":)" : "smile.png", ":(" : "sad.png", ";)" : "wink.png", ":P" : "razz.png", ":D" : "grin.png", ":|" : "plain.png", ":O" : "surprise.png", ":?" : "confused.png", "8)" : "glasses.png", "8o" : "eek.png", "B)" : "cool.png", ":-)" : "smile-big.png", ":-(" : "crying.png", ":-*" : "kiss.png", "O:-D" : "angel.png", "&gt;:-D" : "devilish.png", ":o)" : "monkey.png", ":idea:" : "idea.png", ":important:" : "important.png", ":help:" : "help.png", ":error:" : "error.png", ":warning:" : "warning.png", ":favorite:" : "favorite.png"};

jQuery.preg_quote = function (str) {
        var specials = new RegExp("[.*+?|()\\[\\]{}\\\\]", "g"); // .*+?|()[]{}\
        return str.replace(specials, "\\$&");
};

jQuery.fn.insertAtCaret = function (myValue) {

    return this.each(function() {

        //IE support
        if (document.selection) {

        this.focus();
        sel = document.selection.createRange();
        sel.text = myValue;
        this.focus();

        } else if (this.selectionStart || this.selectionStart == '0') {
            //MOZILLA / NETSCAPE support
            var startPos = this.selectionStart;
            var endPos = this.selectionEnd;
            var scrollTop = this.scrollTop;
            this.value = this.value.substring(0, startPos)+ myValue+ this.value.substring(endPos,this.value.length);
            this.focus();
            this.selectionStart = startPos + myValue.length;
            this.selectionEnd = startPos + myValue.length;
            this.scrollTop = scrollTop;
        } else {
            this.value += myValue;
            this.focus();
        }
    });
};

jQuery.stripslashes = function (str) {
        str = str.replace(/\\'/g,'\'');
        str = str.replace(/\\"/g,'"');
        str = str.replace(/\\\\/g,'\\');
        str = str.replace(/\\0/g,'\0');
        return str;
};

// Triggered to update quick-chat-history-container with new data
function quick_chat_update(){
	jQuery.post("index.php", {
            quick_chat_update: jQuery("input.quick-chat-last-timestamp").val()},
	    function(data){
	        if(data.success==1){
	        updates = data.updates;
	            for(i=0;updates[i]!=undefined;i++){
	                // Replace for smiles
	                for (smilie in smileArray){
	                    updates[i].message = updates[i].message.replace(new RegExp(jQuery.preg_quote(smilie), 'g'), "<img src=\""+quick_chat_url+"emotions/"+smileArray[smilie]+"\" title=\""+smilie+"\"/>");                       
	                }
                        jQuery("input.quick-chat-last-timestamp").val(updates[i].timestamp);
                        var string = "<div class=\"quick-chat-history-message-alias-container\"><span class=\"quick-chat-history-alias\">"+updates[i].alias+"</span><span class=\"quick-chat-history-timestring\">["+updates[i].timestring+"]:</span>";
                        if(quick_chat_is_admin == 1){
                            string += "<input class=\"quick-chat-to-delete-boxes\" type=\"checkbox\" name=\"quick-chat-to-delete[]\" value=\""+updates[i].id+"\" />";                
                        }                         
                        string += "<span class=\"quick-chat-history-message\">"+jQuery.stripslashes(updates[i].message)+"</span></div>";
                      
	                jQuery(".quick-chat-history-container").html(jQuery(".quick-chat-history-container").html()+ string);
                    }
	        }
                
                if(data.timestamp!=undefined) jQuery("input.quick-chat-last-timestamp").val(data.timestamp);
	        quick_chat_update();
                
                // Refresh chat
                quick_chat_refresh();
	    },
	    'json'
	);
}

function quick_chat_refresh(){
    // Just scroll to the bottom on new message
    //jQuery(".quick-chat-history-container").scrollTop(jQuery(".quick-chat-history-container")[0].scrollHeight);

    // Animate and scroll to the bottom on new message
    jQuery('.quick-chat-history-container').animate({scrollTop: jQuery('.quick-chat-history-container')[0].scrollHeight}, 500);        
}

// Use jQuery via $j(...)
jQuery(document).ready(function(){
    // Refresh chat
    quick_chat_refresh();   

    // Triggered on enter key down to check is enter pressed
    jQuery('.quick-chat-message').keypress(function(e) {
        code = e.keyCode ? e.keyCode : e.which;
        if(code.toString() == 13) {
            e.preventDefault();
            
            var messageText = jQuery(this).val();
            jQuery(this).val("");
            var messageAuthor = jQuery(this).prev().val();
            
            jQuery.post("index.php", {alias: messageAuthor, message: messageText});
        }
    });        

    setTimeout("quick_chat_update()", 1000);

    // Smilies effects
    jQuery("div.quick-chat-smilies-container img").bind('click', function() {
        jQuery(this).fadeOut(100, function() {
            var activeImg = jQuery(this).parent().prev();
            activeImg.insertAtCaret(jQuery(this).attr('title'));
            jQuery(this).fadeIn(100);
        });
    });

    if(quick_chat_is_admin == 1){    
        jQuery("div.quick-chat-delete-link a").bind('click', function(e) {
            e.preventDefault();
            
            // Prevent default
            var to_delete_ids = [];
            jQuery(this).parents('form').find("input:checked").each(function(){
                to_delete_ids.push(jQuery(this).val());
            });

            if(to_delete_ids == ""){
                alert(delete_what_string);
            } else{
                jQuery(this).parents('form').submit()
            }
        });
        var quick_chat_toggle = false;
        jQuery("div.quick-chat-select-all-link a").bind('click', function(e) {
            e.preventDefault();
            jQuery(this).parents("form.quick-chat-delete-form").find("input[type=checkbox]").attr("checked",!quick_chat_toggle);
            quick_chat_toggle = !quick_chat_toggle; 
        });       
    }
});
