<?php
/*
Plugin Name: Quick Chat
Plugin URI: http://www.techytalk.info/quick-chat
Description: Quick Chat is elegant WordPress chat plugin. Quick Chat supports in post embedding, bad words filtering, emoticons, translation and css customization.
Author: Marko Martinović
Version: 1.51
Author URI: http://www.techytalk.info
License: GPL2

Copyright 2011.  Marko Martinović  (email : marko AT techytalk.info)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, version 2, as
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

global $default_quick_chat_db_version;
global $default_badwords_list;
global $default_tld_blocklist;
global $default_name;
global $default_keep_around_count;
global $default_name;
global $default_guest_num_digits;

global $quick_chat_options;
global $quick_chat_db_version;
global $quick_chat_url;
global $quick_chat_path;
global $is_embedded;

global $date_format;
global $time_format;
global $gmt_offset;

$default_badwords_list = '4r5e, 5h1t, 5hit, a55, anal, ar5e, arrse, arse, ass, ass-fucker, assfucker, assfukka, asshole, asswhole, b!tch, b00bs, b17ch, b1tch, ballbag, balls, ballsack, bastard, beastiality, bi+ch, bitch, bloody, blowjob, boiolas, boobs, booobs, boooobs, booooobs, booooooobs, breasts, buceta, bunny fucker, buttmuch, c0ck, c0cksucker, cawk, chink, cipa, cl1t, clit, clit, clits, cnut, cock, cock-sucker, cockface, cockhead, cockmunch, cockmuncher, cocksucker, cocksuka, cocksukka, cok, cokmuncher, coksucka, cox, cum, cunt, cyalis, d1ck, dick, dickhead, dildo, dirsa, dlck, dog-fucker, doggin, dogging, donkeyribber, doosh, duche, ejakulate, f u c k e r, f4nny, fag, faggitt, faggot, fanny, fannyflaps, fannyfucker, fanyy, fatass, fcuk, fcuker, fcuking, feck, fecker, fook, fooker, fuck, fuck, fucka, fucker, fuckhead, fuckin, fucking, fuckingshitmotherfucker, fuckwhit, fuckwit, fuk, fuker, fukker, fukkin, fukwhit, fukwit, fux, fux0r, gaylord, goatse, heshe, hoare, hoer, hore, jackoff, jism, kawk, knob, knobead, knobed, knobhead, knobjocky, knobjokey, l3i+ch, l3itch, m0f0, m0fo, m45terbate, ma5terb8, ma5terbate, master-bate, masterb8, masterbat, masterbat3, masterbation, masterbations, masturbate, mo-fo, mof0, mofo, motherfucker, motherfuckka, mutha, muthafecker, muthafuckker, muther, mutherfucker, n1gga, n1gger, nazi, nigg3r, nigg4h, nigga, niggah, niggas, niggaz, nigger, nob, nob jokey, nobhead, nobjocky, nobjokey, numbnuts, nutsack, p0rn, pawn, penis, penisfucker, phuck, pigfucker, pimpis, piss, pissflaps, porn, prick, pron, pusse, pussi, pussy, rimjaw, rimming, s.o.b., schlong, scroat, scrote, scrotum, sh!+, sh!t, sh1t, shag, shagger, shaggin, shagging, shemale, shi+, shit, shit, shitdick, shite, shited, shitey, shitfuck, shithead, shitter, slut, smut, snatch, spac, t1tt1e5, t1tties, teets, teez, testical, testicle, titfuck, tits, titt, tittie5, tittiefucker, titties, tittyfuck, tittywank, titwank, tw4t, twat, twathead, twatty, twunt, twunter, v14gra, v1gra, viagra, w00se, wang, wank, wanker, wanky, whoar, whore, willies, willy, vagina';
$default_tld_blocklist = 'com, info, org, edu, net, biz, xxx';
$default_name = __('Guest_','quick-chat');
$default_keep_around_count = '0';
$default_guest_num_digits = '3';
$default_quick_chat_db_version = '4';

$date_format = get_option('date_format');
$time_format = get_option('time_format');
$gmt_offset = get_option('gmt_offset');

$quick_chat_options = get_option('quick_chat_options');
$quick_chat_db_version = get_option('quick_chat_db_version');
$quick_chat_url = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));
$quick_chat_path = WP_PLUGIN_DIR.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));
$is_embedded = false;

function qc_load_translation_files(){
    $plugin_path = dirname(plugin_basename(__FILE__));
    load_plugin_textdomain( 'quick-chat', false, $plugin_path.'/languages/' );
}
add_action('init','qc_load_translation_files');

// Enqueue stylesheet files, if it exists.
function qc_load_stylesheet() {
    global $quick_chat_url;
    global $quick_chat_path;
    $myStyleUrl = $quick_chat_url . 'quick-chat.css';
    $myStyleFile = $quick_chat_path . 'quick-chat.css';
    if ( file_exists($myStyleFile) ) {
        wp_register_style('myStyleSheets', $myStyleUrl);
        wp_enqueue_style( 'myStyleSheets');
    }
}
add_action('wp_print_styles', 'qc_load_stylesheet');

// Smilies array
$smileArray = array(
               ':)' => 'smile.png',
		':(' => 'sad.png',
		';)' => 'wink.png',
		':P' =>'razz.png',
		':D' =>'grin.png',
		':|' => 'plain.png',
		':O' => 'surprise.png',
		':?' => 'confused.png',
		'8)' => 'glasses.png',
		'8o' => 'eek.png',
		'B)' => 'cool.png',
		':-)' => 'smile-big.png',
		':-(' => 'crying.png',
		':-*' => 'kiss.png',
		'O:-D' => 'angel.png',
		'&gt;:-D' => 'devilish.png',
		':o)' => 'monkey.png',
		':idea:' =>'idea.png',
		':important:' => 'important.png',
		':help:' => 'help.png',
		':error:' => 'error.png',
		':warning:' => 'warning.png',
		':favorite:' => 'favorite.png'
                );

/* Filter bad words and links class */
class Filter_String {
    public $text = '';  // string to check for bad words and bad domains
    public $bad_words = array();  //array of bad words
    public $blocked_tlds = array(); //array of bad domains
    public $replace_inside_bad_words = true;
    public $keep_first_last = false;

    public function filter(){        
        if($this->text != ''){
            if(!empty($this->bad_words)){
                $this->text = $this->do_filter($this->text, $this->bad_words, $this->keep_first_last, $this->replace_inside_bad_words);
            }

            if(!empty($this->blocked_tlds)){
                /* Construct regex from user defined domains */
                /* First regex part */
                $regex = '/\S+\.(?:';
                foreach($this->blocked_tlds as $blocked_tld){
                    if($blocked_tld == end($this->blocked_tlds)){
                        // Last element without "|" at the end
                        $regex .=  trim($blocked_tld);
                    } else {
                        $regex .=  trim($blocked_tld).'|';
                    }
                }
                /* last regex part */
                $regex .= ')/i';

                preg_match_all($regex, $this->text, $urls_found2D,PREG_SET_ORDER);
                
                /* preg_match_all returns 2D array, we need 1D */
                foreach($urls_found2D as $key => $value){
                    foreach($value as $subkey => $subvalue){
                        $urls_found1D[] = $subvalue;
                    }
                }
                if(!empty($urls_found1D))$this->text = $this->do_filter($this->text, $urls_found1D, false, true);                    
            }            
        }
        return $this->text;
    }

    private function do_filter($text, $strings, $keep_first_last, $replace_inside_words){
            foreach($strings as $word){
                /* Strip possible spaces left after csv explode */
                $word = trim($word);

                $replacement = '';

                $str = strlen($word);

                $first = ($keep_first_last) ? $word[0] : '';
                $str = ($keep_first_last) ? $str - 2 : $str;
                $last = ($keep_first_last) ? $word[strlen($word) - 1] : '';

                $replacement = str_repeat('*', $str);

                if($replace_inside_words){

                    if($this->keep_first_last){
                        // Match words with first char uppercase (case sensitive)
                        $text = str_replace($word, $first.$replacement.$last, $text);                        
                        
                        // Match words with first char uppercase (case sensitive)
                        $text = str_replace(ucfirst($word), strtoupper($first).$replacement.$last, $text);
                    } else{
                        // Match words with first char uppercase (case sensitive)
                        $text = str_ireplace($word, $first.$replacement.$last, $text);                          
                    }
                }
                else{
                    if($this->keep_first_last){
                        // Match words with first char uppercase (case sensitive)
                        $text = preg_replace('/\b'.$word.'\b/', $first.$replacement.$last, $text);

                        // Match words with first char uppercase (case sensitive)
                        $text = preg_replace('/\b'.ucfirst($word).'\b/', strtoupper($first).$replacement.$last, $text);
                    } else{
                        // Match words with first char uppercase (case insensitive)
                        $text = preg_replace('/\b'.$word.'\b/i', $first.$replacement.$last, $text);
                    }
                }
            }
        return $text;
    }   
}

// Installation function
function quick_chat_install() {
    global $wpdb;
    global $default_badwords_list;
    global $default_tld_blocklist;
    global $default_quick_chat_db_version;
    global $default_name;
    global $default_keep_around_count;
    global $default_guest_num_digits;
    global $quick_chat_options;
    global $quick_chat_db_version;   
    $table_name = $wpdb->prefix . "quick_chat";

   if($wpdb->get_var('SHOW TABLES LIKE \''.$table_name.'\';') != $table_name) {
       $sql = 'CREATE TABLE `'.$table_name.'` (
          `id` bigint(20) unsigned NOT NULL auto_increment,
          `timestamp` int(10) unsigned default NULL,
          `alias` varchar(100) default NULL,
          `ip` varchar(15) default NULL,
          `message` text,
          PRIMARY KEY  (`id`)
        ) ENGINE=MyISAM DEFAULT CHARACTER SET utf8, COLLATE utf8_general_ci;';

        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
        dbDelta($sql);
        
        // Update db version
        $quick_chat_db_version = $default_quick_chat_db_version;
   } elseif($quick_chat_db_version < 4){
       // This is upgrade from v3 database to v4 database, we need to alter table
       $query = $wpdb->query( 'ALTER TABLE `'.$table_name.'` MODIFY `alias` varchar(100), MODIFY `ip` varchar(15);');
       
        // Update db version
       $quick_chat_db_version = $default_quick_chat_db_version;
   }
   
    if(!isset($quick_chat_options['default_name'])) {
        $quick_chat_options['default_name'] = $default_name;        
    }

    if(!isset($quick_chat_options['badwords_list'])) {
        $quick_chat_options['badwords_list'] = $default_badwords_list;        
    }    

    if(!isset($quick_chat_options['tld_blocklist'])) {
        $quick_chat_options['tld_blocklist'] = $default_tld_blocklist;        
    }
    
    if(!isset($quick_chat_options['allow_logged_in_choice'])) {
        $quick_chat_options['allow_logged_in_choice'] = '1';        
    }
    
    if(!isset($quick_chat_options['allow_guests_choice'])) {
        $quick_chat_options['allow_guests_choice'] = '1';        
    }
    
    if(!isset($quick_chat_options['replace_inside_bad_words'])) {
        $quick_chat_options['replace_inside_bad_words'] = '1';        
    }
    
    if(!isset($quick_chat_options['hide_widget_if_embedded'])) {
        $quick_chat_options['hide_widget_if_embedded'] = '1';        
    }  
    
    if(!isset($quick_chat_options['keep_around_count'])) {
        $quick_chat_options['keep_around_count'] = $default_keep_around_count;        
    }
    
    if(!isset($quick_chat_options['guest_num_digits'])) {
        $quick_chat_options['guest_num_digits'] = $default_guest_num_digits;        
    }
    
    if(!isset($quick_chat_options['max_name_length'])) {
        $quick_chat_options['max_name_length'] = strlen($quick_chat_options['default_name']) + $quick_chat_options['guest_num_digits'];        
    }
    
    update_option('quick_chat_db_version', $quick_chat_db_version);     
    update_option('quick_chat_options', $quick_chat_options);
}

function quick_chat_update_db_check() {
    global $quick_chat_db_version;
    global $default_quick_chat_db_version;
    
    if ($quick_chat_db_version != $default_quick_chat_db_version) {
        quick_chat_install();
    }
}
add_action('plugins_loaded', 'quick_chat_update_db_check');

// Quick chat plugin init
function quick_chat_init(){
    global $wpdb;
    global $quick_chat_options;
    global $smileArray;
    global $date_format;
    global $time_format;
    global $gmt_offset;     
    $table_name = $wpdb->prefix . "quick_chat";

    
    if(isset($_POST['quick-chat-to-delete']) && !empty($_POST['quick-chat-to-delete'])){
        // Messages have been deleted
        foreach ($_POST['quick-chat-to-delete'] as $value) {
            $wpdb->get_results('DELETE FROM '.$table_name.' WHERE id ='.$value);
        }
        
    } else if(isset($_POST['alias']) && isset($_POST['message']) && wp_filter_nohtml_kses(trim($_POST['alias']))!="" && wp_filter_nohtml_kses(trim($_POST['message']))!=""){
        // Message has been sent
        $filter = new Filter_String;

        if(isset($quick_chat_options['badwords_list']) && ($quick_chat_options['badwords_list'] != '')){
            $filter->bad_words = explode(',', $quick_chat_options['badwords_list']);
        }

        if(isset($quick_chat_options['tld_blocklist']) && ($quick_chat_options['tld_blocklist'] != '')) {
            $filter->blocked_tlds = explode(',', $quick_chat_options['tld_blocklist']);
        }
        
        if(isset($quick_chat_options['replace_inside_bad_words'])) {
            $filter->replace_inside_bad_words = true;
        } else{
            $filter->replace_inside_bad_words = false;
        }
        
        if(isset($quick_chat_options['keep_first_last'])) {
            $filter->keep_first_last = true;
        } else{
            $filter->keep_first_last = false;
        }
        
        $filter->text = wp_filter_nohtml_kses($_POST['message']);
        $filteredMessage = $filter->filter();
        
        $filter->text = wp_filter_nohtml_kses($_POST['alias']);
        $filteredAlias = $filter->filter();
        
        if (is_user_logged_in()){
            setcookie("quick_chat_loggedin_alias",$_POST['alias'],0,"/");
        }else{
            setcookie("quick_chat_guest_alias",$_POST['alias'],0,"/");
        }
        $rows_affected = $wpdb->insert( $table_name, array( 'timestamp' => time(), 'alias' => $filteredAlias, 'message' => $filteredMessage,'ip'=>$_SERVER['REMOTE_ADDR']) );
        exit;
    }

    // Updates
    if(isset($_POST['quick_chat_update']) && (int)$_POST['quick_chat_update']!=0){        
        $startTime = time();
        while((time()-$startTime)<=25){
            //the loop
            $history = $wpdb->get_results( "SELECT * FROM $table_name WHERE timestamp>".$_POST['quick_chat_update']." ORDER BY timestamp DESC" );
            if($history){
                // there is an update
                foreach($history as $v){
                    $v->timestring = date_i18n($date_format.' - '.$time_format, $v->timestamp+($gmt_offset* 3600));
                }                
                echo json_encode(array('success'=>1,'updates'=>$history));exit;
            }else{//no updates
                sleep(1);
            }
        }
        echo json_encode(array('success'=>0));exit;
    }
}
add_action('init','quick_chat_init');

function quick_chat_js() {
    global $quick_chat_url;
    
    /* jQuery */
    wp_enqueue_script('jquery');
    
    // Latest jQuery
    //wp_deregister_script('jquery');
    //wp_register_script('jquery', ('http://ajax.googleapis.com/ajax/libs/jquery/1/jquery.min.js'), false);
    //wp_enqueue_script('jquery'); 
    
    // Register Javascripts
    wp_enqueue_script('quick-chat', ($quick_chat_url."js/quickchat.js"), array('jquery'), false, true);
    
    // Pass PHP variables to the Javascript code.
    wp_localize_script( 'quick-chat', 'custom', array   (
                                                            'quick_chat_url' => $quick_chat_url,
                                                            'quick_chat_date_fmt' => get_option('date_format'),
                                                            'quick_chat_time_fmt' => get_option('time_format'),
                                                            'quick_chat_is_admin' => current_user_can('manage_options'),
                                                            'delete_what_string' => __('You must select at least one message.','quick-chat')
                                                        ));
    
}
add_action('wp_head', 'quick_chat_js', 1);

function quick_chat_admin_js() {
    global $quick_chat_url;      
    if(strstr($_SERVER['REQUEST_URI'], 'quick-chat.php')){   
        /* jQuery admin script */
        wp_enqueue_script('quick-chat_admin', ($quick_chat_url."js/quickchat_admin.js"), array('jquery'), false, false);
    }
}
add_action('admin_init', 'quick_chat_admin_js');

// Register our settings. Add the settings section, and settings fields
function quick_chat_init_fn(){
    register_setting('quick_chat_options', 'quick_chat_options', 'quick_chat_options_validate' );
    
    add_settings_section('general_section', __('Main options','quick-chat'), 'section_general_fn', __FILE__);
    add_settings_section('filter_section', __('Filter options','quick-chat'), 'section_filter_fn', __FILE__);
    add_settings_section('security_section', __('Security options','quick-chat'), 'section_security_fn', __FILE__);    
    add_settings_section('appearance_section', __('Appearance options','quick-chat'), 'section_appearance_fn', __FILE__);  
    
    add_settings_field('quick_chat_def_name', __('Chat name prefix for guest users:','quick-chat'), 'setting_defname_fn', __FILE__, 'general_section');
    add_settings_field('quick_chat_guest_num_digits', __('Maximum number of digits for random guests chat user name sufix:','quick-chat'), 'setting_guest_num_digits_fn', __FILE__, 'general_section');
    add_settings_field('quick_chat_max_name_length', __('Maximum length of guest chat user name (keep in mind first two options in this section):','quick-chat'), 'setting_max_name_length_fn', __FILE__, 'general_section');
    add_settings_field('quick_chat_keep_around_count', __('Keep number of messages automatically around this value (enter "0" to disable):','quick-chat'), 'setting_keep_around_count_fn', __FILE__, 'general_section');
    
    add_settings_field('quick_chat_keep_first_last', __('Keep first and last letter of filtered word:','quick-chat'), 'setting_keep_first_last_fn', __FILE__, 'filter_section');
    add_settings_field('quick_chat_replace_inside_bad_words', __('Filter bad words contained inside other words:','quick-chat'), 'setting_replace_inside_bad_words_fn', __FILE__, 'filter_section');
    add_settings_field('quick_chat_bad_words', __('Bad words list (comma separated):','quick-chat'), 'setting_badwords_fn', __FILE__, 'filter_section');    
    add_settings_field('quick_chat_tld_blocklist', __('Filter URLs to the following domains (comma separated):','quick-chat'), 'setting_tld_blocklist_fn', __FILE__, 'filter_section');
    
    add_settings_field('quick_chat_only_logged_in_users', __('Only logged in users can use chat:','quick-chat'), 'setting_only_logged_in_users_fn', __FILE__, 'security_section');
    add_settings_field('quick_chat_allow_guests_choice', __('Allow guest users to choose their chat user names:','quick-chat'), 'setting_allow_guests_choice_fn', __FILE__, 'security_section');        
    add_settings_field('quick_chat_allow_logged_in_choice', __('Allow logged in users to choose their chat user names:','quick-chat'), 'setting_allow_logged_in_choice_fn', __FILE__, 'security_section');
    
    add_settings_field('quick_chat_hide_widget_if_embedded', __('Hide Quick Chat sidebar widget on pages where Quick Chat is embeded in post:','quick-chat'), 'setting_hide_widget_if_embedded_fn', __FILE__, 'appearance_section');
    add_settings_field('quick_chat_hide_linkhome', __('Hide "Powered by Quick Chat" link (big thanks for not hiding it):','quick-chat'), 'setting_hide_linkhome_fn', __FILE__, 'appearance_section');
}
add_action('admin_init', 'quick_chat_init_fn' );

// Add sub page to the Settings Menu
function quick_chat_add_page_fn() {
    add_options_page('Quick Chat '.__('options page','quick-chat'), 'Quick Chat ', 'administrator', __FILE__, 'options_page_fn');
}
add_action('admin_menu', 'quick_chat_add_page_fn');


// Admin options functions
function  section_general_fn() {
    echo '<p>';
    _e('Here you can control all general options:','quick-chat');
    echo '</p>';
}

// Admin options functions
function  section_filter_fn() {
    echo '<p>';
    _e('Here you can control Quick Chat message and chat user names filter:','quick-chat');
    echo '</p>';
}
// Admin options functions
function  section_security_fn() {
    echo '<p>';
    _e('In this section you can control security options:','quick-chat');
    echo '</p>';
}
// Admin options functions
function  section_appearance_fn() {
    echo '<p>';
    _e('Here are the Quick Chat appearance options:','quick-chat');
    echo '</p>';
}

function setting_defname_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_def_name" name="quick_chat_options[default_name]" size="14" type="text" value="'.__($quick_chat_options['default_name'],'quick-chat').'" />';
}


function setting_keep_around_count_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_keep_around_count" name="quick_chat_options[keep_around_count]" size="7" type="text" value="'.$quick_chat_options['keep_around_count'].'" />';
}


function setting_max_name_length_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_max_name_length" name="quick_chat_options[max_name_length]" size="7" type="text" value="'.$quick_chat_options['max_name_length'].'" />';
}


function setting_guest_num_digits_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_guest_num_digits" name="quick_chat_options[guest_num_digits]" size="7" type="text" value="'.$quick_chat_options['guest_num_digits'].'" />';
}

function setting_tld_blocklist_fn() {
    global $quick_chat_options;
    echo '<textarea id="quick_chat_tld_blocklist" name="quick_chat_options[tld_blocklist]" rows="7" cols="50" type="textarea">'.$quick_chat_options['tld_blocklist'].'</textarea>';
}

function setting_badwords_fn() {
    global $quick_chat_options;
    echo '<textarea id="quick_chat_bad_words" name="quick_chat_options[badwords_list]" rows="7" cols="50" type="textarea">'.$quick_chat_options['badwords_list'].'</textarea>';
}

function setting_replace_inside_bad_words_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_replace_inside_bad_words" name="quick_chat_options[replace_inside_bad_words]" type="checkbox" value="1" ';
    if(isset($quick_chat_options['replace_inside_bad_words'])) echo 'checked="checked"';
    echo '/>';
}

function setting_keep_first_last_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_keep_first_last" name="quick_chat_options[keep_first_last]" type="checkbox" value="1" ';
    if(isset($quick_chat_options['keep_first_last'])) echo 'checked="checked"';
    echo '/>';
}

function setting_hide_widget_if_embedded_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_hide_widget_if_embedded" name="quick_chat_options[hide_widget_if_embedded]" type="checkbox" value="1" ';
    if(isset($quick_chat_options['hide_widget_if_embedded'])) echo 'checked="checked"';
    echo '/>';
}

function setting_hide_linkhome_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_hide_linkhome" name="quick_chat_options[hide_linkhome]" type="checkbox" value="1" ';
    if(isset($quick_chat_options['hide_linkhome'])) echo 'checked="checked"';
    echo '/>';
}

function setting_allow_logged_in_choice_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_allow_logged_in_choice" name="quick_chat_options[allow_logged_in_choice]" type="checkbox" value="1" ';
    if(isset($quick_chat_options['allow_logged_in_choice'])) echo 'checked="checked"';
    echo '/>';
}

function setting_only_logged_in_users_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_only_logged_in_users" name="quick_chat_options[only_logged_in_users]" type="checkbox" value="1" ';
    if(isset($quick_chat_options['only_logged_in_users'])) echo 'checked="checked"';
    echo '/>';
}

function setting_allow_guests_choice_fn() {
    global $quick_chat_options;
    echo '<input id="quick_chat_allow_guests_choice" name="quick_chat_options[allow_guests_choice]" type="checkbox" value"1" ';
    if(isset($quick_chat_options['allow_guests_choice'])) echo 'checked="checked"';
    if(isset($quick_chat_options['only_logged_in_users'])) echo 'disabled="disabled"';
    echo '/>';
}

// Display the admin options page
function options_page_fn() {
?>
    <div class="wrap">
        <div class="icon32" id="icon-options-general"><br></div>
        <h2>Quick Chat</h2>
        <form action="options.php" method="post">
        <?php settings_fields('quick_chat_options'); ?>
        <?php do_settings_sections(__FILE__); ?>
        <p class="submit">
                <input name="Submit" type="submit" class="button-primary" value="<?php esc_attr_e('Save Changes'); ?>" />
        </p>
        </form>
    </div>
<?php
}

// Validate user data for all of our input fields
function quick_chat_options_validate($input) {
    global $default_name;
    global $default_keep_around_count;
    global $default_guest_num_digits;
    
    // Validate default name
    if(trim($input['default_name']) == ''){
        $input['default_name'] =  $default_name;;
    } else{
        $input['default_name'] =  wp_filter_nohtml_kses(trim($input['default_name']));
    }
    
    // Validate keep around count
    if(!is_numeric($input['keep_around_count']) || $input['keep_around_count'] < 0){
        $input['keep_around_count'] =  $default_keep_around_count;
    }
    
    // Check our badwords field contains no HTML tags - if so strip them out
    $input['badwords_list'] =  wp_filter_nohtml_kses(trim($input['badwords_list']));
    
    // Check our badwords field contains no HTML tags - if so strip them out
    $input['tld_blocklist'] =  wp_filter_nohtml_kses(trim($input['tld_blocklist']));
    
    
    if(!is_numeric($input['guest_num_digits'])){
        $input['guest_num_digits'] =  $default_guest_num_digits;
    } else if($input['guest_num_digits'] < 1){
        $input['guest_num_digits'] =  '1';
    } elseif($input['guest_num_digits'] > 10){
        $input['guest_num_digits'] =  '10';
    }    
    
    // Validate maximum length of chat user name
    if(!is_numeric($input['max_name_length']) || ($input['max_name_length'] < (strlen($input['default_name']) + $input['guest_num_digits']))){
        $input['max_name_length'] =  strlen($input['default_name']) + $input['guest_num_digits'];
    }    
    return $input; // return validated input      
}

function generate_random_letters($length) {
  $random = '';
  for ($i = 0; $i < $length; $i++) {
    $random .= chr(rand(ord('a'), ord('z')));
  }
  return $random;
}

// Widget code generator
function quick_chat_display_chat($height) {
    ob_start();
    global $smileArray;
    global $quick_chat_options;
    global $quick_chat_url;
    global $wpdb;
    global $date_format;
    global $time_format;
    global $gmt_offset;    
    $table_name = $wpdb->prefix . "quick_chat";

    $stringAll = '';

    $history = $wpdb->get_results( "SELECT * FROM $table_name ORDER BY timestamp DESC" );
    
    if (current_user_can('manage_options')) echo '<form class="quick-chat-delete-form" name="quick-chat-delete-form" action="" method="post">';   
    
    echo '<div class="quick-chat-history-container" style="height: '.$height.'px;">';
    if($history!=null){       
        /* Cleanup */
        $cleanupLimit = intval($quick_chat_options['keep_around_count'] * 1.2);
        if($quick_chat_options['keep_around_count'] != 0 && count($history) > $cleanupLimit){
            $last_id = $wpdb->get_var('SELECT max(id) FROM '.$table_name);
            $toCleanLimit = intval($quick_chat_options['keep_around_count'] * 0.8);
            /* Delete last N */
            $wpdb->get_results( 'DELETE FROM '.$table_name.' WHERE id < ( '.$last_id.' - '.$toCleanLimit.' )');
            /* Refresh history */
            $history = $wpdb->get_results( "SELECT * FROM $table_name ORDER BY timestamp DESC" );
        }
        
        // Go through history messages and replace smile signs for smile images
        foreach($history as $v){
            foreach($smileArray as $smile_sign => $smile_img) $v->message = str_replace($smile_sign, '<img title="'.$smile_sign.'" src="'.$quick_chat_url.'emotions/'.$smile_img.'" />', $v->message);          
            // After we replace all, we simply print results
            $string = ' <div class="quick-chat-history-message-alias-container"><span class="quick-chat-history-alias">'.$v->alias.'</span>';
            $string .= '<span class="quick-chat-history-timestring">['.date_i18n($date_format.' - '.$time_format,$v->timestamp+($gmt_offset* 3600)).']:</span>';
            if (current_user_can('manage_options')){
                $string .= '<input class="quick-chat-to-delete-boxes" type="checkbox" name="quick-chat-to-delete[]" value="'.$v->id.'" />';
            }            
            $string .= '<span class="quick-chat-history-message">'.stripslashes($v->message).'</span></div>';

            $stringAll = $string.$stringAll;
        }
        echo $stringAll;
    }  
    echo '</div><input type="hidden" name="quick-chat-last-timestamp" class="quick-chat-last-timestamp" value="'.time().'" />';
    if (current_user_can('manage_options')) echo '<div class="quick-chat-links"><div class="quick-chat-delete-link"><a href="">'.__('Delete selected','quick-chat').'</a></div><div class="quick-chat-select-all-link"><a href="">'.__('Toggle all','quick-chat').'</a></div><div style="clear: both;"></div></div></form>';   
    
    
    global $current_user;
    get_currentuserinfo();
    
    /* If only logged in allowed to use chat */
    if(isset($quick_chat_options['only_logged_in_users'])){
        /* Registered use it... */
        if (is_user_logged_in()){
            echo '<input class="quick-chat-alias" type="text" autocomplete="off" value="';
            if(isset($quick_chat_options['allow_logged_in_choice'])){
                if(isset($_COOKIE['quick_chat_loggedin_alias'])){
                    echo $_COOKIE['quick_chat_loggedin_alias'].'"';
                }else{
                    echo $current_user->user_login.'"';
                } 
            } else{
                echo $current_user->user_login.'" readonly="readonly"';
            }
        echo ' />';

        echo '<textarea class="quick-chat-message"></textarea><div class="quick-chat-smilies-container">';
        foreach($smileArray as $smile_sign => $smile_img) echo '<img style="float: left; margin: 2px;" title="'.$smile_sign.'" src="'.$quick_chat_url.'emotions/'.$smile_img.'" />';
        echo '<div style="clear: both;"></div></div>';
        
        /* Non logged in use it... */
        } else{
            echo '<div class="quick-chat-login-to-use-notice">'.__('You must login if you want to participate in chat.','quick-chat').'</div>';
        }        

    } else{
        if (is_user_logged_in()){
            echo '<input class="quick-chat-alias" type="text" autocomplete="off" value="';
            if(isset($quick_chat_options['allow_logged_in_choice'])){
                if(isset($_COOKIE['quick_chat_loggedin_alias'])){
                    echo $_COOKIE['quick_chat_loggedin_alias'].'"';
                }else{
                    echo $current_user->user_login.'"';
                } 
            } else{
                echo $current_user->user_login.'" readonly="readonly"';
            }
        } else{
            echo '<input class="quick-chat-alias" type="text" autocomplete="off" maxlength="'.$quick_chat_options['max_name_length'].'" value="';
            $maxNumWithNumDigits = '';
            $numDigits = $quick_chat_options['guest_num_digits'];
            for($i=0; $i<$numDigits; $i++){
                $maxNumWithNumDigits .= '9';
            }
            
            if(isset($quick_chat_options['allow_guests_choice'])){
                if(isset($_COOKIE['quick_chat_guest_alias'])){
                    echo substr($_COOKIE['quick_chat_guest_alias'], 0, strlen($quick_chat_options['default_name']) + $quick_chat_options['guest_num_digits']).'"';
                } else{
                    echo __($quick_chat_options['default_name'],'quick-chat').mt_rand(0, $maxNumWithNumDigits).'"';
                }
            } else{
                echo __($quick_chat_options['default_name'],'quick-chat').mt_rand(0, $maxNumWithNumDigits).'" readonly="readonly"';
            }
        }        
        echo ' />';

        echo '<textarea class="quick-chat-message"></textarea><div class="quick-chat-smilies-container">';
        foreach($smileArray as $smile_sign => $smile_img) echo '<img style="float: left; margin: 2px;" title="'.$smile_sign.'" src="'.$quick_chat_url.'emotions/'.$smile_img.'" />';
        echo '<div style="clear: both;"></div></div>';        
    }

    if(!isset($quick_chat_options['hide_linkhome'])){
        echo '<div class="quick-chat-linkhome"><a href="http://www.techytalk.info/quick-chat" target="_blank">'.__('Powered by Quick Chat','quick-chat').'</a></div>';
        echo '<div style="clear: both;"></div>';
    }

    $content =  ob_get_contents();
    ob_end_clean();
    return $content;
}

// WP Widget class
class Quick_Chat extends WP_Widget {
    public $name = 'Quick Chat';
    /* Widget control settings. */
    public $control_options = array(
       'width' => 250,
       'height' => 300,
       'id_base' => 'quick-chat-widget');

    public function __construct() {
        $widget_options = array(
          'classname' => __CLASS__,
          'description' => __('Quick Chat is quick and elegant WordPress chat plugin that does not waste your bandwidth.','quick-chat'));

        parent::__construct($this->control_options['id_base'], $this->name, $widget_options);
    }
    
    // Widget admin code
    function form ($instance) {
        $defaults = array('title'=>'Quick Chat','widgetheight' => '250');
        $instance = wp_parse_args( (array) $instance, $defaults );
        ?>

        <p>
        <label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title') ?>:</label>
        <input type="text" name="<?php echo $this->get_field_name('title') ?>" id="<?php echo $this->get_field_id('title') ?> " value="<?php echo $instance['title'] ?>" size="20">
        </p>

        <p>
        <label for="<?php echo $this->get_field_id('widgetheight'); ?>"><?php _e('Message container height:','quick-chat') ?></label>
        <input type="text" name="<?php echo $this->get_field_name('widgetheight') ?>" id="<?php echo $this->get_field_id('widgetheight') ?> " value="<?php echo $instance['widgetheight'] ?>" size="5">
        </p>
        <?php
    }
    
    // Update widget code
    function update ($new_instance, $old_instance) {
        $instance = $old_instance;

        $instance['widgetheight'] = $new_instance['widgetheight'];
        $instance['title'] = $new_instance['title'];
        return $instance;
    }
    
    // Widget looks
    function widget ($args,$instance) {
        extract($args);
        $title = $instance['title'];
        $widgetheight = $instance['widgetheight'];
        global $is_embedded;
        global $quick_chat_options;
        
        // We show widget if hide widget option isn't turned on or QC isn't embedded in current page
        if(!$is_embedded || !isset($quick_chat_options['hide_widget_if_embedded'])){
            // Print the widget for the sidebar
            echo $before_widget;
            echo $before_title.$title.$after_title;
            
            // We call widget printing function
            echo quick_chat_display_chat($widgetheight);

            echo $after_widget;
        }
    }
}

function fn_load_widgets() {
  register_widget('Quick_Chat');
}
add_action('widgets_init', 'fn_load_widgets');

// Shortcode
function quick_chat_shortcode_handler( $atts, $content=null, $code="" ) {
    extract(shortcode_atts( array('height' => '300'), $atts ));
    global $is_embedded;
    
    $is_embedded = true;
    $content = quick_chat_display_chat($height);
    return $content;
}
add_shortcode( 'quick-chat', 'quick_chat_shortcode_handler' );

function quick_chat_uninstall() {
	global $wpdb;
	$table_name = $wpdb->prefix."quick_chat"; 

	if(get_option('quick_chat_options')) delete_option('quick_chat_options');
        if(get_option('quick_chat_db_version')) delete_option('quick_chat_db_version');
	if(get_option('widget_quick-chat-widget')) delete_option('widget_quick-chat-widget');
	$wpdb->query("DROP TABLE IF EXISTS $table_name");
}
register_uninstall_hook(__FILE__, 'quick_chat_uninstall');
/* End of file quick-chat.php */
